#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ColorScheme {
    #[serde(rename = "TURBO")]
    Turbo,
    #[serde(rename = "MAGMA")]
    Magma,
    #[serde(rename = "VIRIDIS")]
    Viridis,
    #[serde(rename = "PLASMA")]
    Plasma,
    #[serde(rename = "INFERNO")]
    Inferno,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ColorScheme {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ColorScheme::Turbo => "TURBO",
            ColorScheme::Magma => "MAGMA",
            ColorScheme::Viridis => "VIRIDIS",
            ColorScheme::Plasma => "PLASMA",
            ColorScheme::Inferno => "INFERNO",
            ColorScheme::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ColorScheme {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ColorScheme {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ColorScheme {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<ColorScheme, conjure_object::plain::ParseEnumError> {
        match v {
            "TURBO" => Ok(ColorScheme::Turbo),
            "MAGMA" => Ok(ColorScheme::Magma),
            "VIRIDIS" => Ok(ColorScheme::Viridis),
            "PLASMA" => Ok(ColorScheme::Plasma),
            "INFERNO" => Ok(ColorScheme::Inferno),
            v => v.parse().map(|v| ColorScheme::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ColorScheme {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ColorScheme, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ColorScheme enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
